/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.statistik.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.statistik.entity.StatistikLauf;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class StatistikLaufExtendedDAO extends AbstractStatistikLaufDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: StatusNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM StatistikLauf o WHERE o.status = ?1 ORDER by o.zeitpunktDesLaufs ASC<br>
* SQL: <br>
*/
@Override
public java.util.List<StatistikLauf> findByStatus( @javax.annotation.Nonnull de.ivu.elect.business.statistik.entity.StatistikLaufStatus status,  int limit) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("StatistikLauf.findByStatus" ,  status  ,  limit);

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByStatus(): Miss");
        }

        cache.put(key, super.findByStatus( status  ,  limit));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByStatus(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<StatistikLauf>) cache.lookup(key));
    }

    return super.findByStatus( status  ,  limit);
}
/**
* Name: WahlterminNichtWahlAusloeserNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT o FROM StatistikLauf o WHERE o.wahltermin=?1 AND o.wahl IS NULL AND o.ausloeser=?2<br>
* SQL: <br>
*/
@Override
public java.util.List<StatistikLauf> findByWahlterminNichtWahlAusloeser( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull String ausloeser) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("StatistikLauf.findByWahlterminNichtWahlAusloeser" ,  wahltermin ,  ausloeser  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlterminNichtWahlAusloeser(): Miss");
        }

        cache.put(key, super.findByWahlterminNichtWahlAusloeser( wahltermin ,  ausloeser  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlterminNichtWahlAusloeser(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<StatistikLauf>) cache.lookup(key));
    }

    return super.findByWahlterminNichtWahlAusloeser( wahltermin ,  ausloeser  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
